#ifndef ENEMY_H
#define ENEMY_H

#include <cpctelera.h>
#include "GameTypes.h"
#include "Object.h"
#include "sprites/EnemySprites.h"
#include "Projectile.h"
#include "Map.h"
#include "Timer.h"
#include "Mediator.h"

//enemy types
#define ENEMY_TYPE_DOWN_DROPPER 0
#define ENEMY_TYPE_DOWN_LASER 1
#define ENEMY_TYPE_UP_DOWN2 2
#define ENEMY_TYPE_LEFT_RIGHT2 3
#define ENEMY_TYPE_LEFT_RIGHT 4
#define ENEMY_TYPE_UP_DOWN 5

//enemy states
#define ENEMY_STATE_INACTIVE 0
#define ENEMY_STATE_ACTIVE 1

//directions
#define ENEMY_LEFT -1
#define ENEMY_RIGHT 1
#define ENEMY_UP -1
#define ENEMY_DOWN 1

typedef struct Enemy Enemy;

struct Enemy
{
    Object object;
    u8 type;
    u8 spriteNumber;
    u8 state : 1;
    Projectile projectile;
    i8 direction : 2; //left and right
	Position previousPosition;
};

extern Enemy mapEnemies[MAX_ENEMY];

extern u8 mapEnemyCount;

//draw enemy to screen
void drawEnemy(Enemy* enemy);

void logicEnemy(Enemy* enemy);

//toggle a state change on the enemy and cleanup as required
void activateEnemy(Enemy* enemy);

//calculate the grid positions that the enemy currently occupies
void calculateEnemyOccupiedXGridPositions(u8 xPosition, i8 xVelocity, u8 width);
void calculateEnemyOccupiedYGridPositions(u8 yPosition, i8 yVelocity, u8 height);

#endif