#ifndef HUD_H
#define HUD_H

#include <cpctelera.h>
#include "GameTypes.h"
#include "Map.h"
#include "Fitzroy.h"
#include "sprites/HudSprites.h"

//this is the HUD at the bottom of the screen that displays current information to the player about 
//their state and the general game state.

typedef struct Hud Hud;

struct Hud
{    
    u16 gameScore;
    u8 redraw;
    void (*drawHud)(Hud*);    
};

//setup the hud
void initHud(Hud* hud);

//adds to the gamescore that is displayed on the hud
void addToScore(Hud* hud, u16 addedScore);

extern Hud gameHud;

//we use this to display the score on the hud and on the victory/game over screen
extern u8 scoreHud[6];

void convertIntToChar(u16 input, u8 output[6]);

//converts an integer used by the timer (max 255) to a char array with leading 0s
void timerIntToChar(u8 input, u8 output[4]);

//add an item to the hud when it is picked up
void addItemToHud(Hud* hud, u8 itemType);

//remove item from hud (only applies to keys)
void removeItemFromHud(Hud* hud, u8 itemType);

//draw the game timer for when the time changes
void drawGameTimer(Hud* hud);

#endif