#include "Item.h"

void pickupItem(Item* item)
{
	//only pickup the item once
	//clearing the item is done outside the item object
	if (item->inInventory == FALSE)
	{
		item->inInventory = TRUE;

		//update the score for picking up the item
		addToScore(&gameHud, ITEM_SCORE);

		//display item on hud
		addItemToHud(&gameHud, item->type);

		if(item->type == ITEM_TYPE_MAGNIFYING_GLASS)
		{
			activateMagnifyingGlass();
		}
	}	
}

u8 hasItem(u8 itemType)
{
	u8 i = 0;
	
	for(i = 0; i<mapItemCount; ++i)
	{
		//make sure the item is both being carried and of the correct type
		if(mapItems[i].inInventory == TRUE && mapItems[i].type == itemType)
		{
			if (itemType == ITEM_TYPE_KEY || itemType == ITEM_TYPE_KEY2 || itemType == ITEM_TYPE_KEYCARD || itemType == ITEM_TYPE_SPANNER)
			{
				//keys, spanners and keycards are single use and should be removed from the inventory immediately
				mapItems[i].inInventory = FALSE;

				//remove the key from the hud
				removeItemFromHud(&gameHud, itemType);

				//redraw the hud
				gameHud.redraw = TRUE;
			}			

			return TRUE;
		}
	}

	return FALSE;
}