#ifndef ITEM_H
#define ITEM_H

#include <cpctelera.h>
#include "GameTypes.h"
#include "Object.h"
#include "sprites/ItemSprites.h"
#include "Hud.h"
#include "MagnifyingGlass.h"

//Item types
#define ITEM_TYPE_KEY 0
#define ITEM_TYPE_SPANNER 1
#define ITEM_TYPE_KEYCARD 2
#define ITEM_TYPE_HAMMER 3
#define ITEM_TYPE_SHOES 4
#define ITEM_TYPE_MAGNIFYING_GLASS 5
#define ITEM_TYPE_KEY2 6
#define ITEM_TYPE_CHAIR 7

#define ITEM_SCORE 100

typedef struct Item Item;

struct Item
{
    Position position;
    u8 type;
    u8 spriteNumber;
	u8 inInventory : 1; //determines if an item is currently being carried by Fitzroy in the inventory
};

extern Item mapItems[MAX_ITEM];

extern u8 mapItemCount;

//pickup an item and put itin the inventory
void pickupItem(Item* item);

//check to see if there is an item of that type being carried
u8 hasItem(u8 itemType);

#endif