#ifndef MAP_H
#define MAP_H

#include <cpctelera.h>
#include "GameTypes.h"
#include "maps/Maps.h"
#include "Interactable.h"
#include "Enemy.h"
#include "Item.h"
#include "sprites/TileSprites.h"
#include "Cell.h"
#include "Mediator.h"
#include "Hidden.h"

//used for accessing the map array throughout the code
extern u8* mapArray;

extern i8 mapFitzroyXPosition;
extern i8 mapFitzroyYPosition;

extern u8 mapXTileCount;

extern u8 mapRedraw;

void initMap(u8 selectedLevel);

//draw the current map
void drawMap();

void chooseMap(u8 selectedLevel);

void destroyMap();

//populate the interactable struct with the raw values from the interactable array in the map file
void loadInteractables(const u8* rawMapInteractables);

//populate the enemy struct with the raw values from the enemy array in the map file
void loadEnemies(const u8* rawMapEnemies);

//populate the item struct with the raw values from the item array in the map file
void loadItems(const u8* rawMapItems);

void logicMap();

#endif