#ifndef PROJECTILE_H
#define PROJECTILE_H

#include <cpctelera.h>
#include "Object.h"
#include "GameTypes.h"
#include "Mediator.h"

#define PROJECTILE_WIDTH 2
#define DROPPER_PROJECTILE_HEIGHT 8

typedef struct Projectile Projectile;

struct Projectile
{
	Position previousPosition;
    Object object;
    u8 exists : 1;
    u8 moves : 1; //determines if a projectile moves or if it is static
	u8 end;
    u8 startY;
};

void initProjectile(Projectile* projectile, Object* enemyObject, u8 width, u8 height, u8 projectileEnd, u8 moves);

void drawProjectile(Projectile* projectile);

void logicProjectile(Projectile* projectile);

void clearProjectile(Projectile* projectile);

#endif