#include "Timer.h"

u16 timerCount_ = 0;
u8 invincibilityActive = FALSE;
u8 enemyTimerCount = 0;
u8 levelTimerActive = FALSE;
u8 levelTimerSeconds = 0;
u8 levelTimerCount_ = 0;

void timerInterruptHandler()
{
    if(invincibilityActive && timerCount_++ > 1100)
    {
		invincibilityActive = FALSE;
        timerCount_ = 0;
    }

	if (enemyTimerCount++ > 100)
	{
		enemyTimerCount = 0;
	}

	//200 was pretty close to a minute
	if(levelTimerActive && levelTimerCount_++ > 210 )
	{
		levelTimerCount_ = 0;

		//count down one second
		if(levelTimerSeconds > 0)
		{
			--levelTimerSeconds;
			
			//update the game timer on the hud
			drawGameTimer(&gameHud);
		}
		else
		{
			//times up game over
			gameRunning = FALSE;
			gameResult = LOSS;
		}
	}
}

void startInvincibilityTimer()
{
	timerCount_ = 0;
	invincibilityActive = TRUE;
}

void startLevelTimer()
{
	levelTimerCount_ = 0;
	levelTimerActive = TRUE;
}

void stopLevelTimer()
{
	levelTimerCount_ = 0;
	levelTimerActive = FALSE;
}